"""
ECE 590
Project 3 : Arbitrage
Fall 2021

Partner 1: Afsana Chowdhury (ahc35)
Partner 2: N/A
Date: 11/10/2021

Program Description: 
Implementing Bellman-Ford to detect arbitrage opportunities given a
set of exchange rates between currencies.
"""

# Import math and p3tests.
import math
from p3tests import *

################################################################################

"""
Function: detectArbitrage

Inputs:
1) adjList: the adjacency list representing the currencies graph.
2) adjMat: the adjacency matrix representing the exchange rates,
as generated by the rates2mat function.
3) tol: tolerance which is set at 1e-15 as default.

Output:
A single list of vertex ranks corresponding to the negative cost cycle.
This list needs to start and end at the same rank.

Description: This function implements Bellman-Ford
to find a negative clock cycle and thus any arbitrage opportunity.
"""
def detectArbitrage(adjList, adjMat, tol=1e-15):
    initGraph(adjList)

    # Step-1: Perform the |V| - 1 iterations of Bellman-Ford,
    # taking the tol value into account.
    # Step-2: Perform the extra iteration and track changes
    # in the vertex.dist values.
    cycleVertex = None;

    # Iterate |V| times for step-1 and step-2
    for iter in range(0, len(adjList)) :
    	# Look at each vertex
    	for u in adjList :
    		# Check each neighbour of u
    		# Update predictions and previous vertex
    		for neighbour in u.neigh :
    			length = adjMat[u.rank][neighbour.rank]
    			# Only update if the new value is better!
    			if neighbour.dist > u.dist + length + tol :
    				neighbour.dist = u.dist + length
    				neighbour.prev = u
    				# check if anything is updating
    				# during the extra iteration
    				if(iter == len(adjList) - 1) : 
    					cycleVertex = neighbour
    					break
    			# No need to check other vertices
    			# if something changed in the last iteration
    			if(cycleVertex != None) :
    				break
    		# since this is the last iteration
    		# we don't need to break out of the outer-most loop
    		# for the cycleVertex

    # Step-3: Choose a single vertex that had a change and follow its path
    # backwards (using the vertex.prev values) until we find a cycle.
    # Note that this cycle does not necessarily include the changed vertex
    # we started with.
    if(cycleVertex != None) : # i.e. something got updated at last iteration
    	cycle = []
    	
    	# check if the vertex is already in the list
    	while not (cycleVertex.rank in cycle) :
    		cycle.append(cycleVertex.rank)
    		cycleVertex = cycleVertex.prev

    	# if we're here that means we have found the repeated vertex
    	# Now we need to add that vertex to complete the cycle
    	# since the list needs to start and end at the same rank
    	cycle.append(cycleVertex.rank)

    	# Step- 4: Once we have this path, remove any vertices that are not
    	# part of the cycle, and reverse the list as we traced the path
    	# backwards. This cycle will be our return value.

    	# Since we know the last element in the list is the repeated element,
    	# we can find the index of the first occurenece of the element in 
    	# the list and then slice the list at that index.
    	startVertex = cycle[len(cycle) - 1]
    	repeatedIndex = cycle.index(startVertex)
    	cycle = cycle[repeatedIndex:]
    	#now reverse
    	cycle.reverse()

    	return cycle

    else : # no negative cycle as nothing changed at the last iteration
    	return []

################################################################################

"""
Function: rates2mat

Input:
rates: A matrix with exchange rates between currencies

Output:
adjMat: Adjacency matrix with correctly weighted edges
in the currency graph for detecting arbitrage opportunity
"""
def rates2mat(rates):
	# For two vertex (currency) u and v in the graph
	# the edge between these two vertices
	# length(u,v) = log(1/R(u,v) = - log R(u,v)
    return [[(-math.log(R, 2)) for R in row] for row in rates]

"""
Function: 

Input:
adjList

Description: Sets initial dist and prev for every vertex
in currency graph. Also sets the "start" vertex's dist to 0.
"""
def initGraph(adjList):
	for vertex in adjList:
		vertex.dist = math.inf
		vertex.prev = None
	start = adjList[0]
	start.dist = 0
	return

"""
Main function.
"""
if __name__ == "__main__":
    testRates()
